<?php
/**
 * TorrentTrader v2.0 RC1
 *  - Coded by Sqrtboy (sqrtboy@phpsoft.org)
 *  - Released under the GPL licence
 *  - Support/Hacks/Discussion @ http://www.torrenttrader.com
 *  - Email: sqrtboy@phpsoft.org
 **/
 
session_start();
require_once('core.php');

/* check user is a member */
tt_members_only();

/* initiate template class */
tt_template_start('Upload');

/* check member */
tt_members_only();

$tpl->addVar('announce_url', $announce_url);

/* define page functions */
function validfilename($name)
	{
	return preg_match('/^[^\0-\x1f:\\\\\/?*\xff#<>|]+$/si', $name);
	}

function unesc($x)
	{
    if (get_magic_quotes_gpc())
    	{
        return stripslashes($x);
    	}
    return $x;
	}

/* get list of categories */
$result = $db->query('SELECT id, name FROM '.$dbprfx.'categories');
while ($row = $db->fetch_array($result))
	{
	$categorylist[] = array(
	'id' => $row['id'],
	'name' => $row['name']);
	}
	$tpl->addVar('categorylist', $categorylist);

/* get list of usergroups */
$result = $db->query('SELECT id, name FROM '.$dbprfx.'groups');
while ($row = $db->fetch_array($result))
	{
	$categorygroup[] = array(
	'id' => $row['id'],
	'name' => $row['name']);
	}
	$tpl->addVar('categorygroup', $categorygroup);

/* prepare inputs */
$upload_do = isset($_POST['upload_do']) ? addslashes($_POST['upload_do']) : false;
$upload_name = isset($_POST['name']) ? addslashes($_POST['name']) : false;
$upload_description = isset($_POST['description']) ? addslashes($_POST['description']) : false;
$upload_category = isset($_POST['category']) ? addslashes($_POST['category']) : false;
$upload_language = isset($_POST['language']) ? addslashes($_POST['language']) : false;
$usergroups = isset($_POST['usergroups']) ? (int)$_POST['usergroups'] : false;
$upload_errors = false;
$upload_success = false;
$errors = false;


/* process form */
if($upload_do)
	{
	for( $check = 0; $check < 1; $check++)
		{
		$filename = unesc($_FILES['torrentfile']["name"]);
		$tmpname = $_FILES['torrentfile']["tmp_name"];
		$dict = bdec_file($tmpname,filesize($tmpname));
		
				

		/* make sure all fields were entered */
		if(!$_FILES['torrentfile'] || !$upload_category || !$upload_language || !$usergroups)
			{
			tt_warning('ERROR', 'Please complete all required fields.', 'error');
			$errors = true;
			break;
			}

		/* check if a name was entered */
		if (!empty($upload_name))
			{
			$torrent = unesc($upload_name);
			}

		/* check the hash file */
		if (!isset($_FILES['torrentfile']))
			{
			tt_warning('ERROR', 'You must provide a valid .torrent file.', 'error');
			$errors = true;
			break;
			}

		/* check the hash file */
		if (empty($filename))
			{
			tt_warning('ERROR', 'You must provide a valid .torrent file.', 'error');
			$errors = true;
			break;
			}

		/* check the hash file */
		if (!validfilename($filename))
			{
			tt_warning('ERROR', 'The .torrent has an invalid filename.', 'error');
			$errors = true;
			break;
			}

		/* check the hash file */
		if (empty($filename))
			{
			tt_warning('ERROR', 'Invalid Bittorrent file. Must have a .torrent extension.', 'error');
			$errors = true;
			break;
			}

		/* check torrent file is on server */
		if (!is_uploaded_file($tmpname))
			{
			tt_warning('ERROR', 'Uploaded file could not be found.', 'error');
			$errors = true;
			break;
			}

		/* check torrent file is not empty */
		if (!filesize($tmpname))
			{
			tt_warning('ERROR', 'Invalid Bittorrent file is 0-bytes.', 'error');
			$errors = true;
			break;
			}

		/* check torrent file is an actual .torrent file */
		if (!isset($dict))
			{
			tt_warning('ERROR', 'Although the file has a .torrent extension it is not a Bittorrent file.', 'error');
			$errors = true;
			break;
			}

		/* check the integrity of the .torrent file */
		function dict_check($d, $s)
			{
			if ($d["type"] != "dictionary")
				{
				tt_warning('ERROR', 'Dictionary Error. Check that the hash file is valid.', 'error');
				$errors = true;
				break;
				}
			$a = explode(":", $s);
			$dd = $d["value"];
			$ret = array();
			foreach ($a as $k)
				{
				unset($t);
				if (preg_match('/^(.*)\((.*)\)$/', $k, $m))
					{
					$k = $m[1];
					$t = $m[2];
					}
				if (!isset($dd[$k]))
					{
					tt_warning('ERROR', 'Dictionary Error. Check that the hash file is valid.', 'error');
					$errors = true;
					break;
					}
				if (isset($t))
					{
					if ($dd[$k]["type"] != $t)
						{
						tt_warning('ERROR', 'Dictionary Error. Check that the hash file is valid.', 'error');
						$errors = true;
						break;
						}
					$ret[] = $dd[$k]["value"];
					}
				else
					$ret[] = $dd[$k];
				}
			return $ret;
			}

		function dict_get($d, $k, $t)
			{
			if ($d["type"] != "dictionary")
				{
				tt_warning('ERROR', 'Dictionary Error. Check that the hash file is valid.', 'error');
				$errors = true;
				break;
				}
			$dd = $d["value"];
			if (!isset($dd[$k]))
				return;
			$v = $dd[$k];
			if ($v["type"] != $t)
				{
				tt_warning('ERROR', 'Dictionary Error. Check that the hash file is valid.', 'error');
				$errors = true;
				break;
				}
			return $v["value"];
			}
			
			
			// we check that announce_url is the correct one
			list($ann, $info) = dict_check($dict, "announce(string):info");
			
		    $url_ann = array() ;
			$a=0;
			$announcelist = dict_get($dict, "announce-list","list");
			
		    if (isset($announcelist) && count($announcelist))
		        {
			      foreach ($announcelist as $fn) {
			        $hi = $fn["value"];
		
			         for ($i=0;$i < count($hi);$i++  )
			          {
			          $url_ann[] =  $hi[$i]["value"] ;
			          }
			      }

			      for ($k=0;$k<count($url_ann);$k++)
			      {
			      //echo "<br>".$url_ann[$k]; // debug purposes only
			      if  ($announce_url==$url_ann[$k])  $a+=1;
			      }

			     if ($a<1)
			      	{
					tt_warning('ERROR', 'Invalid announce url! It must be <b>' . $announce_url. '</b>', 'error');
					$errors = true;
					break;
					}
		         }
		     else
		     {
		     if ($ann != $announce_url)
		     	{
				tt_warning('ERROR', 'Invalid announce url! It must be <b>' . $announce_url. '</b>', 'error');
				$errors = true;
				break;
				}
		     }

		list($dname, $plen, $pieces) = dict_check($info, "name(string):piece length(integer):pieces(string)");
  

		if (strlen($pieces) % 20 != 0)
			{
			tt_warning('ERROR', 'Piece Error. Check that the hash file is valid.', 'error');
			$errors = true;
			break;
			}

		$filelist = array();
		$totallen = dict_get($info, "length", "integer");
		if (isset($totallen))
			{
			$filelist[] = array($dname, $totallen);
			$type1 = "single";
			}
			else
			{
			$flist = dict_get($info, "files", "list");
			if (!isset($flist))
				{
				tt_warning('ERROR', 'Piece Error. Check that the hash file is valid.', 'error');
				$errors = true;
				break;
				}
			if (!count($flist))
				{
				tt_warning('ERROR', 'Torrent contains 0 files.', 'error');
				$errors = true;
				break;
				}
			$totallen = 0;
			foreach ($flist as $fn)
				{
				list($ll, $ff) = dict_check($fn, "length(integer):path(list)", "02");
				$totallen += $ll;
				$ffa = array();
				foreach ($ff as $ffe)
					{
					if ($ffe["type"] != "string")
						{
						tt_warning('ERROR', 'Piece Error. Check that the hash file is valid.', 'error');
						$errors = true;
						break;
						}
					$ffa[] = $ffe["value"];
					}
				if (!count($ffa))
					{
					tt_warning('ERROR', 'Piece Error. Check that the hash file is valid.', 'error');
					$errors = true;
					break;
					}
				$ffe = implode("/", $ffa);
				$filelist[] = array($ffe, $ll);
				}
			$type1 = "multi";
			}

		$infohash = strtolower(sha1($info["string"]));
		
		/* check if the .torrent already exists */
		$exists = $db->fetch_row("SELECT id FROM ".$dbprfx."torrents WHERE info_hash = '$infohash'");
		
		
		if($exists['id'] != '')
			{
			tt_warning('ERROR', 'Torrent has already been uploaded on tracker.', 'error');
			$errors = true;
			break;
			}
		}

		if(!$errors)
			{
			
			$db->query("INSERT INTO ".$dbprfx."torrents (`info_hash`, `name`, `filename`, `nfo_filename`, `img_filename`, `descr`, `category`, `lang`, `group`, `size`, `added`, `type`, `files`, `visible`, `owner`) VALUES 
			('".mysql_escape_string($infohash)."','".mysql_escape_string($upload_name)."', '".mysql_escape_string($filename)."', '".mysql_escape_string($_FILES['nfofile']['name'])."', '".mysql_escape_string($_FILES['imagefile']['name'])."', 
			'".$upload_description."','".$upload_category."', '".$upload_language."',".$usergroups.", ".$totallen." , NOW(), '".$type1."', ".count($filelist).", 'yes', ".$CURUSER['id'].")  
			");
			
			
			$id = $db->insert_id();
			move_uploaded_file($tmpname, 'uploads/'.$id.'.torrent');
			
		    $db->query("DELETE FROM ".$dbprfx."torrents_files WHERE torrent = $id");
		    foreach ($filelist as $file) {
			  $db->query("INSERT INTO ".$dbprfx."torrents_files (torrent, filename, size) VALUES ($id, '".mysql_escape_string($file[0])."',".$file[1].")");
		    }
		
			if (isset($_FILES['nfofile'])) {
				move_uploaded_file($_FILES['nfofile']['tmp_name'], "uploads/".$id.".nfo");
			}

			if (isset($_FILES['imagefile'])) {
				move_uploaded_file($_FILES['imagefile']['tmp_name'], "uploads/".$id.substr(strrchr($_FILES['imagefile']['name'], "."), 1));
			}			
	
			$upload_success = true;
			}
	}

/* success message */
if($upload_success)
	{
	tt_warning('SUCCESS', 'The upload was successful.<br><font color="red">Please redownload this torrent and then use the new downloaded torrent in order to seed it on this tracker !</font>', 'success');
	}
	else
	{
	$tpl->display('theme/' . $tt_theme . '/templates/torrents_upload.tpl');
	}

tt_template_end();

?>