<?php
/**
 * TorrentTrader v2.0 RC1
 *  - Coded by Sqrtboy (sqrtboy@phpsoft.org)
 *  - Released under the GPL licence
 *  - Support/Hacks/Discussion @ http://www.torrenttrader.com
 *  - Email: sqrtboy@phpsoft.org
 **/

session_start();
require_once('core.php');

/* initiate template class */
tt_template_start('Signup');

/* define page functions */
function validemail($email)
	{
	return preg_match('/^[\w.-]+@([\w.-]+\.)+[a-z]{2,6}$/is', $email);
	}

function validusername($username)
	{
	global $allowed_username_characters;
	for ($i = 0; $i < strlen($username); ++$i)
		if (strpos($allowed_username_characters, $username[$i]) === false)
		return false;
	return true;
	}

/* get list of themes */
$result = $db->query('SELECT id, name FROM '.$dbprfx.'themes');
while ($row = $db->fetch_array($result))
	{
	$themelist[] = array(
	'id' => $row['id'],
	'name' => $row['name']);
	}
	$tpl->addVar('themelist', $themelist);

/* get list of languages */
$result = $db->query('SELECT id, name FROM '.$dbprfx.'languages');
while ($row = $db->fetch_array($result))
	{
	$langlist[] = array(
	'id' => $row['id'],
	'name' => $row['name']);
	}
	$tpl->addVar('langlist', $langlist);

$tpl->addVar('ip_address', getip());
$tpl->addVar('signup_time', date("l dS of F Y h:i:s"));

/* prepare inputs */
$confim =  isset($_GET['confirm']) ? addslashes($_GET['confirm']) : false;
$signup_do = isset($_POST['signup_do']) ? addslashes($_POST['signup_do']) : false;
$signup_user = isset($_POST['user']) ? addslashes($_POST['user']) : false;
$signup_pass1 = isset($_POST['pass1']) ? addslashes($_POST['pass1']) : false;
$signup_pass2 = isset($_POST['pass2']) ? addslashes($_POST['pass2']) : false;
$signup_email = isset($_POST['email']) ? addslashes($_POST['email']) : false;
$signup_theme = isset($_POST['theme']) ? addslashes($_POST['theme']) : false;
$signup_lang = isset($_POST['lang']) ? addslashes($_POST['lang']) : false;
$signup_disclaimer = isset($_POST['disclaimerverify']) ? addslashes($_POST['disclaimerverify']) : false;
$signup_age = isset($_POST['ageverify']) ? addslashes($_POST['ageverify']) : false;
$signup_errors = false;
$signup_success = false;

/* user registration confirmation */
if($confirm)
{
        $exists = $db->count_rows("SELECT username FROM ".$dbprfx."members WHERE passkey = '$confirm'");
        if($exists != '1')
        {
        tt_warning('ERROR', 'Invalid confirmation code. Please check it !', 'error');
        }
        else
        {
        $db->query("UPDATE ".$dbprfx."members SET status='confirmed' WHERE passkey='".$confirm."'");
        tt_warning('SUCCESS', 'You are now a member!', 'success');
        }

        tt_template_end();
        die;
}

/* process form */
if($signup_do)
	{
	for( $check = 0; $check < 5; $check++)
	{
	/* make sure all fields were entered */
	if(!$signup_user || !$signup_pass1 || !$signup_pass2 || !$signup_email)
		{
		tt_warning('ERROR', 'Please complete all required (<font color=\'#CC0000\'>*</font>) fileds.', 'error');
		$errors = true;
		break;
		}

    /* has user checked the checkboxes ? */
    if($signup_age != 'yes')
        {
        tt_warning('ERROR', 'You have to be over 13 years old in order to register to this site', 'error');
        $errors = true;
        break;
        }

    /* has user checked the checkboxes ? */
    if($signup_disclaimer != 'yes')
        {
        tt_warning('ERROR', 'You must agree with the site\'s disclaimer in order to continue', 'error');
        $errors = true;
        break;
        }

	/* check username length */
	$signup_user = trim($signup_user);
	if(strlen($signup_user) > 25)
		{
		tt_warning('ERROR', 'The maximum username length is 25 characters.', 'error');
		$errors = true;
		break;
		}

	/* check password length */
	if(strlen($signup_pass1) > 25)
		{
		tt_warning('ERROR', 'The maximum password length is 25 characters.', 'error');
		$errors = true;
		break;
		}

	/* check passwords match */
	if($signup_pass1 != $signup_pass2)
		{
		tt_warning('ERROR', 'The passwords do not match.', 'error');
		$errors = true;
		break;
		}

	/* check password is not the same as username */
	if($signup_user == $signup_pass1)
		{
		tt_warning('ERROR', 'The password cannot be the same as the username.', 'error');
		$errors = true;
		break;
		}

	/* is username valid? */
	if(!validusername($signup_user))
		{
		tt_warning('ERROR', 'The username contains forbidden characters.', 'error');
		$errors = true;
		break;
		}

	/* is email valid? */
	if(!validemail($_POST['email']))
		{
		tt_warning('ERROR', 'The email address appears to be invalid.', 'error');
		$errors = true;
		break;
		}

	/* check if username is already in use */
	$exists = $db->count_rows("SELECT username FROM ".$dbprfx."members WHERE username = '$signup_user'");
	if($exists != '0')
		{
		tt_warning('ERROR', 'The username is already in use.', 'error');
		$errors = true;
		break;
		}
	}

	if(!$errors)
		{
        $passkey = md5($signup_user.strtotime("now").md5($signup_pass1));
		/* add information to database */
		$db->query("INSERT INTO ".$dbprfx."members (ip, groups, username, password, passkey, email, status, added, lastvisit, theme, language) VALUES ('". getip() ."', '1', '$signup_user', '" . md5($signup_pass1) . "', '$passkey', '$signup_email', 'pending', NOW(), NOW(), '$signup_theme', '$signup_lang')");
		$success = true;
		}
	}

/* success message */
if($success)
	{
        if ($mail_confirmation != 'YES')
	    tt_warning('SUCCESS', 'You are now a member!', 'success');
        else
        {
                $body = <<<EOD
Your account at $SITENAME has been : APPROVED

Your username is : $signup_user
Your password is : $signup_pass1

Please note them down on a paper !

To confirm your user registration, you have to follow this link:

<a href="$SITEURL/tt.user.signup.php?confirm=$passkey" target="_blank">$SITEURL/tt.user.signup.php?confirm=$passkey</a>

After you do this, you will be able to use your new account.
If you fail to do this, your account will be deleted within a few days.

$SITENAME Admin
EOD;
                ini_set("sendmail_from", "");
                 /* To send HTML mail, you can set the Content-type header. */
                 $headers  = "MIME-Version: 1.0\r\n";
                 $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";

                 /* additional headers */
                 $headers .= "To: $signup_user <$signup_email>\r\n";
                 $headers .= "From: $SITENAME <$SITEEMAIL>\r\n";
                 $headers .= "Cc: $signup_email\r\n";
                 mail($email, "Your $SITENAME User Account", $body, $headers);
                 tt_warning('SUCCESS', 'You have been sent a mail ! Please perform instructions given in this mail to complete your registration.', 'success');
        }
	}
	else
	{
	/* are signups allowed ? */
	if($tt_allow_signups == 'no')
		{
		tt_warning('ERROR', 'Signups are currently disabled.', 'error');
		}
		else
		{
		/* is member logged in ? */
		if($loggedin)
			{
			tt_warning('ERROR', 'You are already logged in. You cannot signup again!', 'error');
			}
			else
			{
			/* is the tracker full ? */
			$result = $db->count_rows("SELECT COUNT(*) FROM ".$dbprfx."members");
			if ($result >= $tt_max_members)
				{
				tt_warning('ERROR', 'The site is full.', 'error');
				}
				else
				{
				$tpl->display('theme/' . $tt_theme . '/templates/user_signup.tpl');
				}
			}
		}
	}


tt_template_end();

?>